#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;

using Syncfusion.Collections;
using Syncfusion.Drawing;
using Syncfusion.ComponentModel;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace StrongTypedCollectionSample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl groupingGrid1;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
			try
			{
				Icon ico = new Icon(Syncfusion.Windows.Forms.WinFormsUtils.FindFile("Icon", "sfgrid.ico"));
				this.Icon = ico ;	
			}
			catch
			{}
			CustomerCollection customers = PopulateCustomers.CreateCustomers();

			this.groupingGrid1.ShowNavigationBar = true;
			this.groupingGrid1.TableControl.HorizontalScrollTips = false;
			this.groupingGrid1.BorderStyle = BorderStyle.FixedSingle;
			this.groupingGrid1.FilterRuntimeProperties = true;

			this.groupingGrid1.DataSource = customers;

			GridEngine engine = this.groupingGrid1.Engine;
            engine.TopLevelGroupOptions.ShowCaption = false;

			GridRelationDescriptorCollection relations = new GridRelationDescriptorCollection();

			// First level
			GridRelationDescriptor rd = AddRelation("Level_0", relations);

			// Subsequent levels
			for (int level = 1; level < 7; level++)
			{
				rd = AddRelation("Level_" + level.ToString(), rd.ChildTableDescriptor.Relations);
			}

			//this.groupingGrid1.TableDescriptor.Relations = relations;
            this.groupingGrid1.TableDescriptor.TableOptions.ShowRowHeader = false;
            this.groupingGrid1.TableDescriptor.TableOptions.ShowTreeLines = true; 
            this.groupingGrid1.NestedTableGroupOptions.ShowColumnHeaders = false;
            this.groupingGrid1.ChildGroupOptions.ShowColumnHeaders = false; 
            this.groupingGrid1.NestedTableGroupOptions.ShowGroupHeader = false;
			this.groupingGrid1.TableOptions.ShowRecordPlusMinus = true;
			this.groupingGrid1.NestedTableGroupOptions.ShowCaptionPlusMinus = false;
			this.groupingGrid1.Table.ExpandAllRecords();
			Syncfusion.Grouping.Diagnostics.IterateThroughNestedDisplayElement(this.groupingGrid1.Table);
		}

		GridRelationDescriptor AddRelation(string name, GridRelationDescriptorCollection relations)
		{
			GridRelationDescriptor children = new GridRelationDescriptor();
			children.RelationKind = RelationKind.UniformChildList;
			children.MappingName = "Children";
			children.Name = name;
			relations.Add(children);
			return children;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.groupingGrid1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.groupingGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// groupingGrid1
			// 
			this.groupingGrid1.BackColor = System.Drawing.SystemColors.Window;
			this.groupingGrid1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.groupingGrid1.Location = new System.Drawing.Point(0, 0);
			this.groupingGrid1.Name = "groupingGrid1";
			this.groupingGrid1.Size = new System.Drawing.Size(560, 374);
			this.groupingGrid1.TabIndex = 1;
			this.groupingGrid1.Text = "groupingGrid1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(560, 374);
			this.Controls.Add(this.groupingGrid1);
			this.Name = "Form1";
			this.Text = "StrongTyped Collection";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.groupingGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{

            # if SyncfusionFramework1_1 || SyncfusionFramework2_0
                Application.EnableVisualStyles();
            # endif
			Application.Run(new Form1());
		}

		GroupingGridPropertyDialog frm;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			frm = new GroupingGridPropertyDialog(this.groupingGrid1);
			Point pt = new Point(this.Right, this.Top);
			frm.Show();
			frm.Bounds = new Rectangle(pt, new Size(350, this.Height));

			
		}

	}
}
